blob: 7c1a6ce4f2d114613d043255b9b97e1840edecd8 [file] [log] [blame]
Jason Kusumabe998f42015-09-03 15:53:13 -07001#!/bin/bash
2
Amin Hassani13520932017-07-26 11:26:05 -07003#
4# Copyright (C) 2015 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
Jason Kusumabe998f42015-09-03 15:53:13 -070018
19# Script to generate a Brillo update for use by the update engine.
20#
21# usage: brillo_update_payload COMMAND [ARGS]
22# The following commands are supported:
23# generate generate an unsigned payload
24# hash generate a payload or metadata hash
25# sign generate a signed payload
Alex Deymo98e691c2016-02-04 21:05:45 -080026# properties generate a properties file from a payload
Amin Hassani13520932017-07-26 11:26:05 -070027# verify verify a payload by recreating a target image.
Tudor Brindusb432db82018-06-29 13:13:27 -070028# check verify a payload using paycheck (static testing)
Jason Kusumabe998f42015-09-03 15:53:13 -070029#
30# Generate command arguments:
Jason Kusuma9a4cae22015-10-08 18:17:57 -070031# --payload generated unsigned payload output file
32# --source_image if defined, generate a delta payload from the specified
33# image to the target_image
34# --target_image the target image that should be sent to clients
Amin Hassani13520932017-07-26 11:26:05 -070035# --metadata_size_file if defined, generate a file containing the size of the
36# payload metadata in bytes to the specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070037#
38# Hash command arguments:
39# --unsigned_payload the input unsigned payload to generate the hash from
40# --signature_size signature sizes in bytes in the following format:
Alex Deymo89ff9e32015-09-15 19:29:01 -070041# "size1:size2[:...]"
Jason Kusumabe998f42015-09-03 15:53:13 -070042# --payload_hash_file if defined, generate a payload hash and output to the
43# specified file
44# --metadata_hash_file if defined, generate a metadata hash and output to the
45# specified file
46#
47# Sign command arguments:
Alex Deymo89ff9e32015-09-15 19:29:01 -070048# --unsigned_payload the input unsigned payload to insert the signatures
49# --payload the output signed payload
50# --signature_size signature sizes in bytes in the following format:
51# "size1:size2[:...]"
52# --payload_signature_file the payload signature files in the following
53# format:
54# "payload_signature1:payload_signature2[:...]"
55# --metadata_signature_file the metadata signature files in the following
56# format:
57# "metadata_signature1:metadata_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -070058# --metadata_size_file if defined, generate a file containing the size of
59# the signed payload metadata in bytes to the
60# specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070061# Note that the number of signature sizes and payload signatures have to match.
Alex Deymo98e691c2016-02-04 21:05:45 -080062#
63# Properties command arguments:
64# --payload the input signed or unsigned payload
65# --properties_file the output path where to write the properties, or
66# '-' for stdout.
Amin Hassani13520932017-07-26 11:26:05 -070067# Verify command arguments:
68# --payload payload input file
69# --source_image verify payload to the specified source image.
70# --target_image the target image to verify upon.
Tudor Brindusb432db82018-06-29 13:13:27 -070071#
72# Check command arguments:
73# Symmetrical with the verify command.
Alex Deymo98e691c2016-02-04 21:05:45 -080074
Jason Kusumabe998f42015-09-03 15:53:13 -070075
Alex Deymo61e1fa82016-01-19 15:16:34 -080076# Exit codes:
77EX_UNSUPPORTED_DELTA=100
78
Jason Kusumaf514c542015-11-05 18:43:45 -080079warn() {
80 echo "brillo_update_payload: warning: $*" >&2
81}
82
Gilad Arnold957ce122015-10-14 16:02:55 -070083die() {
84 echo "brillo_update_payload: error: $*" >&2
85 exit 1
Jason Kusumabe998f42015-09-03 15:53:13 -070086}
87
Gilad Arnold957ce122015-10-14 16:02:55 -070088# Loads shflags. We first look at the default install location; then look for
Amin Hassani2a14d412018-05-31 13:01:09 -070089# crosutils (chroot); finally check our own directory.
Gilad Arnold957ce122015-10-14 16:02:55 -070090load_shflags() {
91 local my_dir="$(dirname "$(readlink -f "$0")")"
92 local path
93 for path in /usr/share/misc {/usr/lib/crosutils,"${my_dir}"}/lib/shflags; do
94 if [[ -r "${path}/shflags" ]]; then
95 . "${path}/shflags" || die "Could not load ${path}/shflags."
96 return
97 fi
98 done
99 die "Could not find shflags."
100}
101
102load_shflags
Jason Kusumabe998f42015-09-03 15:53:13 -0700103
Alex Deymoc64ffd52015-09-25 18:10:07 -0700104HELP_GENERATE="generate: Generate an unsigned update payload."
105HELP_HASH="hash: Generate the hashes of the unsigned payload and metadata used \
106for signing."
107HELP_SIGN="sign: Insert the signatures into the unsigned payload."
Alex Deymo98e691c2016-02-04 21:05:45 -0800108HELP_PROPERTIES="properties: Extract payload properties to a file."
Tudor Brindusb432db82018-06-29 13:13:27 -0700109HELP_VERIFY="verify: Verify a (signed) update payload using delta_generator."
110HELP_CHECK="check: Check a (signed) update payload using paycheck (static \
111testing)."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700112
113usage() {
114 echo "Supported commands:"
115 echo
116 echo "${HELP_GENERATE}"
117 echo "${HELP_HASH}"
118 echo "${HELP_SIGN}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800119 echo "${HELP_PROPERTIES}"
Amin Hassani13520932017-07-26 11:26:05 -0700120 echo "${HELP_VERIFY}"
Tudor Brindusb432db82018-06-29 13:13:27 -0700121 echo "${HELP_CHECK}"
Alex Deymoc64ffd52015-09-25 18:10:07 -0700122 echo
123 echo "Use: \"$0 <command> --help\" for more options."
124}
125
126# Check that a command is specified.
Jason Kusumabe998f42015-09-03 15:53:13 -0700127if [[ $# -lt 1 ]]; then
Tudor Brindusb432db82018-06-29 13:13:27 -0700128 echo "Please specify a command [generate|hash|sign|properties|verify|check]"
Jason Kusumabe998f42015-09-03 15:53:13 -0700129 exit 1
130fi
131
Alex Deymoc64ffd52015-09-25 18:10:07 -0700132# Parse command.
133COMMAND="${1:-}"
134shift
135
136case "${COMMAND}" in
137 generate)
138 FLAGS_HELP="${HELP_GENERATE}"
139 ;;
140
141 hash)
142 FLAGS_HELP="${HELP_HASH}"
143 ;;
144
145 sign)
146 FLAGS_HELP="${HELP_SIGN}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700147 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800148
149 properties)
150 FLAGS_HELP="${HELP_PROPERTIES}"
151 ;;
Amin Hassani13520932017-07-26 11:26:05 -0700152
153 verify)
154 FLAGS_HELP="${HELP_VERIFY}"
155 ;;
156
Tudor Brindusb432db82018-06-29 13:13:27 -0700157 check)
158 FLAGS_HELP="${HELP_CHECK}"
159 ;;
160
Jason Kusumabe998f42015-09-03 15:53:13 -0700161 *)
Alex Deymoc64ffd52015-09-25 18:10:07 -0700162 echo "Unrecognized command: \"${COMMAND}\"" >&2
163 usage >&2
Jason Kusumabe998f42015-09-03 15:53:13 -0700164 exit 1
165 ;;
166esac
167
Jason Kusumabe998f42015-09-03 15:53:13 -0700168# Flags
Alex Deymoc64ffd52015-09-25 18:10:07 -0700169FLAGS_HELP="Usage: $0 ${COMMAND} [flags]
170${FLAGS_HELP}"
171
172if [[ "${COMMAND}" == "generate" ]]; then
173 DEFINE_string payload "" \
174 "Path to output the generated unsigned payload file."
175 DEFINE_string target_image "" \
176 "Path to the target image that should be sent to clients."
177 DEFINE_string source_image "" \
178 "Optional: Path to a source image. If specified, this makes a delta update."
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700179 DEFINE_string metadata_size_file "" \
180 "Optional: Path to output metadata size."
Sen Jiang8e768e92017-06-28 17:13:19 -0700181 DEFINE_string max_timestamp "" \
182 "Optional: The maximum unix timestamp of the OS allowed to apply this \
183payload, should be set to a number higher than the build timestamp of the \
184system running on the device, 0 if not specified."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700185fi
186if [[ "${COMMAND}" == "hash" || "${COMMAND}" == "sign" ]]; then
187 DEFINE_string unsigned_payload "" "Path to the input unsigned payload."
188 DEFINE_string signature_size "" \
189 "Signature sizes in bytes in the following format: size1:size2[:...]"
190fi
191if [[ "${COMMAND}" == "hash" ]]; then
192 DEFINE_string metadata_hash_file "" \
193 "Optional: Path to output metadata hash file."
194 DEFINE_string payload_hash_file "" \
195 "Optional: Path to output payload hash file."
196fi
197if [[ "${COMMAND}" == "sign" ]]; then
198 DEFINE_string payload "" \
199 "Path to output the generated unsigned payload file."
200 DEFINE_string metadata_signature_file "" \
201 "The metatada signatures in the following format: \
202metadata_signature1:metadata_signature2[:...]"
203 DEFINE_string payload_signature_file "" \
204 "The payload signatures in the following format: \
205payload_signature1:payload_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700206 DEFINE_string metadata_size_file "" \
207 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700208fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800209if [[ "${COMMAND}" == "properties" ]]; then
210 DEFINE_string payload "" \
211 "Path to the input signed or unsigned payload file."
212 DEFINE_string properties_file "-" \
213 "Path to output the extracted property files. If '-' is passed stdout will \
214be used."
215fi
Tudor Brindusb432db82018-06-29 13:13:27 -0700216if [[ "${COMMAND}" == "verify" || "${COMMAND}" == "check" ]]; then
Amin Hassani13520932017-07-26 11:26:05 -0700217 DEFINE_string payload "" \
218 "Path to the input payload file."
219 DEFINE_string target_image "" \
220 "Path to the target image to verify upon."
221 DEFINE_string source_image "" \
222 "Optional: Path to a source image. If specified, the delta update is \
223applied to this."
224fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800225
Alex Deymo5fbb1102017-01-12 13:55:52 -0800226DEFINE_string work_dir "${TMPDIR:-/tmp}" "Where to dump temporary files."
Jason Kusumabe998f42015-09-03 15:53:13 -0700227
228# Parse command line flag arguments
229FLAGS "$@" || exit 1
230eval set -- "${FLAGS_ARGV}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700231set -e
Jason Kusumabe998f42015-09-03 15:53:13 -0700232
Alex Deymo5fbb1102017-01-12 13:55:52 -0800233# Override the TMPDIR with the passed work_dir flags, which anyway defaults to
234# ${TMPDIR}.
235TMPDIR="${FLAGS_work_dir}"
236export TMPDIR
237
Alex Deymo89ff9e32015-09-15 19:29:01 -0700238# Associative arrays from partition name to file in the source and target
239# images. The size of the updated area must be the size of the file.
240declare -A SRC_PARTITIONS
241declare -A DST_PARTITIONS
242
Alex Deymo20bdc702016-12-07 21:07:11 -0800243# Associative arrays for the .map files associated with each src/dst partition
244# file in SRC_PARTITIONS and DST_PARTITIONS.
245declare -A SRC_PARTITIONS_MAP
246declare -A DST_PARTITIONS_MAP
247
Sen Jiang788c2d92016-03-09 12:48:40 -0800248# List of partition names in order.
249declare -a PARTITIONS_ORDER
250
Alex Deymo89ff9e32015-09-15 19:29:01 -0700251# A list of temporary files to remove during cleanup.
252CLEANUP_FILES=()
253
Alex Deymo48b502a2015-09-17 19:00:18 -0700254# Global options to force the version of the payload.
255FORCE_MAJOR_VERSION=""
256FORCE_MINOR_VERSION=""
257
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800258# Path to the postinstall config file in target image if exists.
259POSTINSTALL_CONFIG_FILE=""
260
Alex Deymoc97df432015-09-25 17:23:52 -0700261# read_option_int <file.txt> <option_key> [default_value]
262#
263# Reads the unsigned integer value associated with |option_key| in a key=value
264# file |file.txt|. Prints the read value if found and valid, otherwise prints
265# the |default_value|.
266read_option_uint() {
267 local file_txt="$1"
268 local option_key="$2"
269 local default_value="${3:-}"
270 local value
271 if value=$(look "${option_key}=" "${file_txt}" | tail -n 1); then
272 if value=$(echo "${value}" | cut -f 2- -d "=" | grep -E "^[0-9]+$"); then
273 echo "${value}"
274 return
275 fi
276 fi
277 echo "${default_value}"
278}
279
Sen Jiangd0e9a892016-07-22 16:28:07 -0700280# truncate_file <file_path> <file_size>
281#
282# Truncate the given |file_path| to |file_size| using perl.
283# The truncate binary might not be available.
284truncate_file() {
285 local file_path="$1"
286 local file_size="$2"
287 perl -e "open(FILE, \"+<\", \$ARGV[0]); \
288 truncate(FILE, ${file_size}); \
289 close(FILE);" "${file_path}"
290}
291
Alex Deymo89ff9e32015-09-15 19:29:01 -0700292# Create a temporary file in the work_dir with an optional pattern name.
293# Prints the name of the newly created file.
294create_tempfile() {
295 local pattern="${1:-tempfile.XXXXXX}"
296 mktemp --tmpdir="${FLAGS_work_dir}" "${pattern}"
297}
Jason Kusumabe998f42015-09-03 15:53:13 -0700298
299cleanup() {
300 local err=""
Alex Deymo89ff9e32015-09-15 19:29:01 -0700301 rm -f "${CLEANUP_FILES[@]}" || err=1
Jason Kusumabe998f42015-09-03 15:53:13 -0700302
303 # If we are cleaning up after an error, or if we got an error during
304 # cleanup (even if we eventually succeeded) return a non-zero exit
305 # code. This triggers additional logging in most environments that call
306 # this script.
307 if [[ -n "${err}" ]]; then
308 die "Cleanup encountered an error."
309 fi
310}
311
312cleanup_on_error() {
313 trap - INT TERM ERR EXIT
314 cleanup
315 die "Cleanup success after an error."
316}
317
318cleanup_on_exit() {
319 trap - INT TERM ERR EXIT
320 cleanup
321}
322
323trap cleanup_on_error INT TERM ERR
324trap cleanup_on_exit EXIT
325
Alex Deymo48b502a2015-09-17 19:00:18 -0700326
Sen Jiang788c2d92016-03-09 12:48:40 -0800327# extract_image <image> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700328#
329# Detect the format of the |image| file and extract its updatable partitions
330# into new temporary files. Add the list of partition names and its files to the
Sen Jiang788c2d92016-03-09 12:48:40 -0800331# associative array passed in |partitions_array|. If |partitions_order| is
332# passed, set it to list of partition names in order.
Alex Deymo48b502a2015-09-17 19:00:18 -0700333extract_image() {
334 local image="$1"
335
336 # Brillo images are zip files. We detect the 4-byte magic header of the zip
337 # file.
338 local magic=$(head --bytes=4 "${image}" | hexdump -e '1/1 "%.2x"')
339 if [[ "${magic}" == "504b0304" ]]; then
340 echo "Detected .zip file, extracting Brillo image."
341 extract_image_brillo "$@"
342 return
343 fi
344
345 # Chrome OS images are GPT partitioned disks. We should have the cgpt binary
346 # bundled here and we will use it to extract the partitions, so the GPT
347 # headers must be valid.
348 if cgpt show -q -n "${image}" >/dev/null; then
349 echo "Detected GPT image, extracting Chrome OS image."
350 extract_image_cros "$@"
351 return
352 fi
353
354 die "Couldn't detect the image format of ${image}"
355}
356
Sen Jiang788c2d92016-03-09 12:48:40 -0800357# extract_image_cros <image.bin> <partitions_array> [partitions_order]
Alex Deymo89ff9e32015-09-15 19:29:01 -0700358#
Alex Deymo48b502a2015-09-17 19:00:18 -0700359# Extract Chromium OS recovery images into new temporary files.
Alex Deymo89ff9e32015-09-15 19:29:01 -0700360extract_image_cros() {
361 local image="$1"
362 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800363 local partitions_order="${3:-}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700364
365 local kernel root
366 kernel=$(create_tempfile "kernel.bin.XXXXXX")
367 CLEANUP_FILES+=("${kernel}")
368 root=$(create_tempfile "root.bin.XXXXXX")
369 CLEANUP_FILES+=("${root}")
370
371 cros_generate_update_payload --extract \
372 --image "${image}" \
373 --kern_path "${kernel}" --root_path "${root}" \
374 --work_dir "${FLAGS_work_dir}" --outside_chroot
375
Alex Deymo83f2f702015-10-14 14:49:33 -0700376 # Chrome OS uses major_version 1 payloads for all versions, even if the
377 # updater supports a newer major version.
378 FORCE_MAJOR_VERSION="1"
379
Tudor Brindusdda79e22018-06-28 18:03:21 -0700380 eval ${partitions_array}[kernel]=\""${kernel}"\"
381 eval ${partitions_array}[root]=\""${root}"\"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700382
Sen Jiang788c2d92016-03-09 12:48:40 -0800383 if [[ -n "${partitions_order}" ]]; then
Tudor Brindusdda79e22018-06-28 18:03:21 -0700384 eval "${partitions_order}=( \"root\" \"kernel\" )"
Sen Jiang788c2d92016-03-09 12:48:40 -0800385 fi
386
Alex Deymo89ff9e32015-09-15 19:29:01 -0700387 local part varname
Tudor Brindusdda79e22018-06-28 18:03:21 -0700388 for part in kernel root; do
Alex Deymo89ff9e32015-09-15 19:29:01 -0700389 varname="${partitions_array}[${part}]"
390 printf "md5sum of %s: " "${varname}"
391 md5sum "${!varname}"
392 done
393}
394
Sen Jiang3e5804d2018-09-06 15:53:00 -0700395# extract_partition_brillo <target_files.zip> <partitions_array> <partition>
396# <part_file> <part_map_file>
397#
398# Extract the <partition> from target_files zip file into <part_file> and its
399# map file into <part_map_file>.
400extract_partition_brillo() {
401 local image="$1"
402 local partitions_array="$2"
403 local part="$3"
404 local part_file="$4"
405 local part_map_file="$5"
406
407 # For each partition, we in turn look for its image file under IMAGES/ and
408 # RADIO/ in the given target_files zip file.
409 local path path_in_zip
410 for path in IMAGES RADIO; do
411 if unzip -l "${image}" "${path}/${part}.img" >/dev/null; then
412 path_in_zip="${path}"
413 break
414 fi
415 done
416 [[ -n "${path_in_zip}" ]] || die "Failed to find ${part}.img"
417 unzip -p "${image}" "${path_in_zip}/${part}.img" >"${part_file}"
418
419 # If the partition is stored as an Android sparse image file, we need to
420 # convert them to a raw image for the update.
421 local magic=$(head --bytes=4 "${part_file}" | hexdump -e '1/1 "%.2x"')
422 if [[ "${magic}" == "3aff26ed" ]]; then
423 local temp_sparse=$(create_tempfile "${part}.sparse.XXXXXX")
424 echo "Converting Android sparse image ${part}.img to RAW."
425 mv "${part_file}" "${temp_sparse}"
426 simg2img "${temp_sparse}" "${part_file}"
427 rm -f "${temp_sparse}"
428 fi
429
430 # Extract the .map file (if one is available).
431 unzip -p "${image}" "${path_in_zip}/${part}.map" >"${part_map_file}" \
432 2>/dev/null || true
433
434 # delta_generator only supports images multiple of 4 KiB. For target images
435 # we pad the data with zeros if needed, but for source images we truncate
436 # down the data since the last block of the old image could be padded on
437 # disk with unknown data.
438 local filesize=$(stat -c%s "${part_file}")
439 if [[ $(( filesize % 4096 )) -ne 0 ]]; then
440 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
441 echo "Rounding DOWN partition ${part}.img to a multiple of 4 KiB."
442 : $(( filesize = filesize & -4096 ))
443 else
444 echo "Rounding UP partition ${part}.img to a multiple of 4 KiB."
445 : $(( filesize = (filesize + 4095) & -4096 ))
446 fi
447 truncate_file "${part_file}" "${filesize}"
448 fi
449
450 echo "Extracted ${partitions_array}[${part}]: ${filesize} bytes"
451}
452
Sen Jiang788c2d92016-03-09 12:48:40 -0800453# extract_image_brillo <target_files.zip> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700454#
455# Extract the A/B updated partitions from a Brillo target_files zip file into
456# new temporary files.
457extract_image_brillo() {
458 local image="$1"
459 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800460 local partitions_order="${3:-}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700461
Alex Deymo48b502a2015-09-17 19:00:18 -0700462 local partitions=( "boot" "system" )
Alex Deymo168b5352015-11-04 13:51:52 -0800463 local ab_partitions_list
464 ab_partitions_list=$(create_tempfile "ab_partitions_list.XXXXXX")
465 CLEANUP_FILES+=("${ab_partitions_list}")
466 if unzip -p "${image}" "META/ab_partitions.txt" >"${ab_partitions_list}"; then
467 if grep -v -E '^[a-zA-Z0-9_-]*$' "${ab_partitions_list}" >&2; then
468 die "Invalid partition names found in the partition list."
469 fi
Sen Jiang34c711a2017-10-25 17:25:21 -0700470 # Get partition list without duplicates.
471 partitions=($(awk '!seen[$0]++' "${ab_partitions_list}"))
Alex Deymo168b5352015-11-04 13:51:52 -0800472 if [[ ${#partitions[@]} -eq 0 ]]; then
473 die "The list of partitions is empty. Can't generate a payload."
474 fi
475 else
476 warn "No ab_partitions.txt found. Using default."
477 fi
Sen Jiang3e5804d2018-09-06 15:53:00 -0700478 echo "List of A/B partitions for ${partitions_array}: ${partitions[@]}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700479
Sen Jiang788c2d92016-03-09 12:48:40 -0800480 if [[ -n "${partitions_order}" ]]; then
481 eval "${partitions_order}=(${partitions[@]})"
482 fi
483
Alex Deymo83f2f702015-10-14 14:49:33 -0700484 # All Brillo updaters support major version 2.
485 FORCE_MAJOR_VERSION="2"
486
Alex Deymo48b502a2015-09-17 19:00:18 -0700487 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800488 # Source image
489 local ue_config=$(create_tempfile "ue_config.XXXXXX")
Alex Deymoc97df432015-09-25 17:23:52 -0700490 CLEANUP_FILES+=("${ue_config}")
491 if ! unzip -p "${image}" "META/update_engine_config.txt" \
492 >"${ue_config}"; then
493 warn "No update_engine_config.txt found. Assuming pre-release image, \
494using payload minor version 2"
495 fi
Alex Deymo83f2f702015-10-14 14:49:33 -0700496 # For delta payloads, we use the major and minor version supported by the
497 # old updater.
Alex Deymoc97df432015-09-25 17:23:52 -0700498 FORCE_MINOR_VERSION=$(read_option_uint "${ue_config}" \
499 "PAYLOAD_MINOR_VERSION" 2)
Alex Deymo83f2f702015-10-14 14:49:33 -0700500 FORCE_MAJOR_VERSION=$(read_option_uint "${ue_config}" \
501 "PAYLOAD_MAJOR_VERSION" 2)
Alex Deymo61e1fa82016-01-19 15:16:34 -0800502
503 # Brillo support for deltas started with minor version 3.
504 if [[ "${FORCE_MINOR_VERSION}" -le 2 ]]; then
505 warn "No delta support from minor version ${FORCE_MINOR_VERSION}. \
506Disabling deltas for this source version."
507 exit ${EX_UNSUPPORTED_DELTA}
508 fi
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800509 else
510 # Target image
511 local postinstall_config=$(create_tempfile "postinstall_config.XXXXXX")
512 CLEANUP_FILES+=("${postinstall_config}")
513 if unzip -p "${image}" "META/postinstall_config.txt" \
514 >"${postinstall_config}"; then
515 POSTINSTALL_CONFIG_FILE="${postinstall_config}"
516 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700517 fi
518
Sen Jiang3e5804d2018-09-06 15:53:00 -0700519 local part
Alex Deymo48b502a2015-09-17 19:00:18 -0700520 for part in "${partitions[@]}"; do
Sen Jiang3e5804d2018-09-06 15:53:00 -0700521 local part_file=$(create_tempfile "${part}.img.XXXXXX")
522 local part_map_file=$(create_tempfile "${part}.map.XXXXXX")
523 CLEANUP_FILES+=("${part_file}" "${part_map_file}")
524 # Extract partitions in background.
525 extract_partition_brillo "${image}" "${partitions_array}" "${part}" \
526 "${part_file}" "${part_map_file}" &
Alex Deymo48b502a2015-09-17 19:00:18 -0700527 eval "${partitions_array}[\"${part}\"]=\"${part_file}\""
Alex Deymo20bdc702016-12-07 21:07:11 -0800528 eval "${partitions_array}_MAP[\"${part}\"]=\"${part_map_file}\""
Sen Jiang3e5804d2018-09-06 15:53:00 -0700529 done
530}
531
532# cleanup_partition_array <partitions_array>
533#
534# Remove all empty files in <partitions_array>.
535cleanup_partition_array() {
536 local partitions_array="$1"
537 # Have to use eval to iterate over associative array keys with variable array
538 # names, we should change it to use nameref once bash 4.3 is available
539 # everywhere.
540 for part in $(eval "echo \${!${partitions_array}[@]}"); do
541 local path="${partitions_array}[$part]"
542 if [[ ! -s "${!path}" ]]; then
543 eval "unset ${partitions_array}[${part}]"
544 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700545 done
546}
547
Tudor Brindusb432db82018-06-29 13:13:27 -0700548extract_payload_images() {
549 local payload_type=$1
550 echo "Extracting images for ${payload_type} update."
551
552 if [[ "${payload_type}" == "delta" ]]; then
553 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
554 fi
555 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
Sen Jiang3e5804d2018-09-06 15:53:00 -0700556 # Wait for all subprocesses.
557 wait
558 cleanup_partition_array SRC_PARTITIONS
559 cleanup_partition_array SRC_PARTITIONS_MAP
560 cleanup_partition_array DST_PARTITIONS
561 cleanup_partition_array DST_PARTITIONS_MAP
Tudor Brindusb432db82018-06-29 13:13:27 -0700562}
563
564get_payload_type() {
565 if [[ -z "${FLAGS_source_image}" ]]; then
566 echo "full"
567 else
568 echo "delta"
569 fi
570}
571
Jason Kusumabe998f42015-09-03 15:53:13 -0700572validate_generate() {
573 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700574 die "You must specify an output filename with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700575
576 [[ -n "${FLAGS_target_image}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700577 die "You must specify a target image with --target_image FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700578}
579
580cmd_generate() {
Sen Jiang3e5804d2018-09-06 15:53:00 -0700581 local payload_type=$(get_payload_type)
582 extract_payload_images ${payload_type}
Jason Kusumabe998f42015-09-03 15:53:13 -0700583
Alex Deymo48b502a2015-09-17 19:00:18 -0700584 echo "Generating ${payload_type} update."
Alex Deymo168b5352015-11-04 13:51:52 -0800585 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700586 GENERATOR_ARGS=( --out_file="${FLAGS_payload}" )
Alex Deymo168b5352015-11-04 13:51:52 -0800587
588 local part old_partitions="" new_partitions="" partition_names=""
Alex Deymo20bdc702016-12-07 21:07:11 -0800589 local old_mapfiles="" new_mapfiles=""
Sen Jiang788c2d92016-03-09 12:48:40 -0800590 for part in "${PARTITIONS_ORDER[@]}"; do
Alex Deymo168b5352015-11-04 13:51:52 -0800591 if [[ -n "${partition_names}" ]]; then
592 partition_names+=":"
593 new_partitions+=":"
594 old_partitions+=":"
Alex Deymo20bdc702016-12-07 21:07:11 -0800595 new_mapfiles+=":"
596 old_mapfiles+=":"
Alex Deymo168b5352015-11-04 13:51:52 -0800597 fi
598 partition_names+="${part}"
599 new_partitions+="${DST_PARTITIONS[${part}]}"
600 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800601 new_mapfiles+="${DST_PARTITIONS_MAP[${part}]:-}"
602 old_mapfiles+="${SRC_PARTITIONS_MAP[${part}]:-}"
Alex Deymo168b5352015-11-04 13:51:52 -0800603 done
604
605 # Target image args:
606 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700607 --partition_names="${partition_names}"
608 --new_partitions="${new_partitions}"
609 --new_mapfiles="${new_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700610 )
611
Alex Deymo89ff9e32015-09-15 19:29:01 -0700612 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo168b5352015-11-04 13:51:52 -0800613 # Source image args:
Jason Kusumabe998f42015-09-03 15:53:13 -0700614 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700615 --old_partitions="${old_partitions}"
616 --old_mapfiles="${old_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700617 )
Alex Deymo48b502a2015-09-17 19:00:18 -0700618 if [[ -n "${FORCE_MINOR_VERSION}" ]]; then
619 GENERATOR_ARGS+=( --minor_version="${FORCE_MINOR_VERSION}" )
620 fi
621 fi
622
623 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
624 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
Jason Kusumabe998f42015-09-03 15:53:13 -0700625 fi
626
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700627 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
628 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
629 fi
630
Sen Jiang8e768e92017-06-28 17:13:19 -0700631 if [[ -n "${FLAGS_max_timestamp}" ]]; then
632 GENERATOR_ARGS+=( --max_timestamp="${FLAGS_max_timestamp}" )
633 fi
634
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800635 if [[ -n "${POSTINSTALL_CONFIG_FILE}" ]]; then
636 GENERATOR_ARGS+=(
637 --new_postinstall_config_file="${POSTINSTALL_CONFIG_FILE}"
638 )
639 fi
640
Jason Kusumabe998f42015-09-03 15:53:13 -0700641 echo "Running delta_generator with args: ${GENERATOR_ARGS[@]}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700642 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700643
Alex Deymo89ff9e32015-09-15 19:29:01 -0700644 echo "Done generating ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700645}
646
647validate_hash() {
648 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700649 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700650
651 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700652 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700653--unsigned_payload FILENAME"
654
Jason Kusumabe998f42015-09-03 15:53:13 -0700655 [[ -n "${FLAGS_payload_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700656 die "You must specify --payload_hash_file FILENAME"
Jason Kusumaf514c542015-11-05 18:43:45 -0800657
658 [[ -n "${FLAGS_metadata_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700659 die "You must specify --metadata_hash_file FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700660}
661
662cmd_hash() {
Sen Jiangbf1266f2015-10-26 11:29:24 -0700663 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700664 --in_file="${FLAGS_unsigned_payload}" \
665 --signature_size="${FLAGS_signature_size}" \
666 --out_hash_file="${FLAGS_payload_hash_file}" \
667 --out_metadata_hash_file="${FLAGS_metadata_hash_file}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700668
Jason Kusumabe998f42015-09-03 15:53:13 -0700669 echo "Done generating hash."
670}
671
672validate_sign() {
673 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700674 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700675
676 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700677 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700678--unsigned_payload FILENAME"
679
680 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700681 die "You must specify the output signed payload with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700682
683 [[ -n "${FLAGS_payload_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700684 die "You must specify the payload signature file with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700685--payload_signature_file SIGNATURES"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700686
687 [[ -n "${FLAGS_metadata_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700688 die "You must specify the metadata signature file with \
Alex Deymo89ff9e32015-09-15 19:29:01 -0700689--metadata_signature_file SIGNATURES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700690}
691
692cmd_sign() {
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700693 GENERATOR_ARGS=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700694 --in_file="${FLAGS_unsigned_payload}"
695 --signature_size="${FLAGS_signature_size}"
696 --payload_signature_file="${FLAGS_payload_signature_file}"
697 --metadata_signature_file="${FLAGS_metadata_signature_file}"
698 --out_file="${FLAGS_payload}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700699 )
700
701 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
702 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
703 fi
704
705 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700706 echo "Done signing payload."
707}
708
Alex Deymo98e691c2016-02-04 21:05:45 -0800709validate_properties() {
710 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700711 die "You must specify the payload file with --payload FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800712
713 [[ -n "${FLAGS_properties_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700714 die "You must specify a non empty --properties_file FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800715}
716
717cmd_properties() {
718 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700719 --in_file="${FLAGS_payload}" \
720 --properties_file="${FLAGS_properties_file}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800721}
722
Tudor Brindusb432db82018-06-29 13:13:27 -0700723validate_verify_and_check() {
Amin Hassani13520932017-07-26 11:26:05 -0700724 [[ -n "${FLAGS_payload}" ]] ||
725 die "Error: you must specify an input filename with --payload FILENAME"
726
727 [[ -n "${FLAGS_target_image}" ]] ||
728 die "Error: you must specify a target image with --target_image FILENAME"
729}
730
731cmd_verify() {
Tudor Brindusb432db82018-06-29 13:13:27 -0700732 local payload_type=$(get_payload_type)
733 extract_payload_images ${payload_type}
Amin Hassani13520932017-07-26 11:26:05 -0700734
735 declare -A TMP_PARTITIONS
736 for part in "${PARTITIONS_ORDER[@]}"; do
737 local tmp_part=$(create_tempfile "tmp_part.bin.XXXXXX")
738 echo "Creating temporary target partition ${tmp_part} for ${part}"
739 CLEANUP_FILES+=("${tmp_part}")
740 TMP_PARTITIONS[${part}]=${tmp_part}
741 local FILESIZE=$(stat -c%s "${DST_PARTITIONS[${part}]}")
742 echo "Truncating ${TMP_PARTITIONS[${part}]} to ${FILESIZE}"
743 truncate_file "${TMP_PARTITIONS[${part}]}" "${FILESIZE}"
744 done
745
746 echo "Verifying ${payload_type} update."
747 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700748 GENERATOR_ARGS=( --in_file="${FLAGS_payload}" )
Amin Hassani13520932017-07-26 11:26:05 -0700749
750 local part old_partitions="" new_partitions="" partition_names=""
751 for part in "${PARTITIONS_ORDER[@]}"; do
752 if [[ -n "${partition_names}" ]]; then
753 partition_names+=":"
754 new_partitions+=":"
755 old_partitions+=":"
756 fi
757 partition_names+="${part}"
758 new_partitions+="${TMP_PARTITIONS[${part}]}"
759 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
760 done
761
762 # Target image args:
763 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700764 --partition_names="${partition_names}"
765 --new_partitions="${new_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700766 )
767
768 if [[ "${payload_type}" == "delta" ]]; then
769 # Source image args:
770 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700771 --old_partitions="${old_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700772 )
773 fi
774
Amin Hassania566cb62017-08-23 12:36:55 -0700775 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
776 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
777 fi
778
Amin Hassani13520932017-07-26 11:26:05 -0700779 echo "Running delta_generator to verify ${payload_type} payload with args: \
780${GENERATOR_ARGS[@]}"
Sen Jiang6feb15c2018-08-31 15:45:17 -0700781 "${GENERATOR}" "${GENERATOR_ARGS[@]}" || true
Amin Hassani13520932017-07-26 11:26:05 -0700782
Sen Jiang6feb15c2018-08-31 15:45:17 -0700783 echo "Done applying ${payload_type} update."
784 echo "Checking the newly generated partitions against the target partitions"
785 local need_pause=false
786 for part in "${PARTITIONS_ORDER[@]}"; do
787 local not_str=""
788 if ! cmp "${TMP_PARTITIONS[${part}]}" "${DST_PARTITIONS[${part}]}"; then
789 not_str="in"
790 need_pause=true
791 fi
792 echo "The new partition (${part}) is ${not_str}valid."
793 done
794 # All images will be cleaned up when script exits, pause here to give a chance
795 # to inspect the images.
796 if [[ "$need_pause" == true ]]; then
797 read -n1 -r -s -p "Paused to investigate invalid partitions, \
798press any key to exit."
Amin Hassani13520932017-07-26 11:26:05 -0700799 fi
800}
801
Tudor Brindusb432db82018-06-29 13:13:27 -0700802cmd_check() {
803 local payload_type=$(get_payload_type)
804 extract_payload_images ${payload_type}
805
806 local part dst_partitions="" src_partitions=""
807 for part in "${PARTITIONS_ORDER[@]}"; do
808 if [[ -n "${dst_partitions}" ]]; then
809 dst_partitions+=" "
810 src_partitions+=" "
811 fi
812 dst_partitions+="${DST_PARTITIONS[${part}]}"
813 src_partitions+="${SRC_PARTITIONS[${part}]:-}"
814 done
815
816 # Common payload args:
817 PAYCHECK_ARGS=( "${FLAGS_payload}" --type ${payload_type} \
818 --part_names ${PARTITIONS_ORDER[@]} \
819 --dst_part_paths ${dst_partitions} )
820
821 if [[ ! -z "${SRC_PARTITIONS[@]}" ]]; then
822 PAYCHECK_ARGS+=( --src_part_paths ${src_partitions} )
823 fi
824
825 echo "Checking ${payload_type} update."
826 check_update_payload ${PAYCHECK_ARGS[@]} --check
827}
828
Jason Kusumabe998f42015-09-03 15:53:13 -0700829# Sanity check that the real generator exists:
Sen Jiang13519752016-08-02 16:10:52 -0700830GENERATOR="$(which delta_generator || true)"
Jason Kusumabe998f42015-09-03 15:53:13 -0700831[[ -x "${GENERATOR}" ]] || die "can't find delta_generator"
832
833case "$COMMAND" in
834 generate) validate_generate
835 cmd_generate
836 ;;
837 hash) validate_hash
838 cmd_hash
839 ;;
840 sign) validate_sign
841 cmd_sign
842 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800843 properties) validate_properties
844 cmd_properties
845 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700846 verify) validate_verify_and_check
Amin Hassani13520932017-07-26 11:26:05 -0700847 cmd_verify
848 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700849 check) validate_verify_and_check
850 cmd_check
851 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700852esac